package UserInt;

/* This class was originally developed with the assumption that
   only applets still used any version less than 1.1 (ie, 1.0).
   This is not true.  So the interface to the rest of the Java
   client is being enhanced;  we are separating the version from the
   type of client (application vs. applet), and instead of assuming
   version based on client type, we are now calculating it.
*/
public class  ApplType  extends Object
{
    private static  String   interpVersion;
    private static  boolean  isApplet;
    private static  boolean  isVers1_0;

    private static void determineInterpVersion()
    {
	interpVersion = System.getProperty ("java.version");
/* TEST
	System.out.println ("Java interpreter version: " + interpVersion);
*/
	// If the version number is not a Sun(R) version number, we have
	// seen the sun version still labelled in the string:
	//
	int   index;
	if ((index = interpVersion.indexOf ("Sun")) >= 0)          ;
        else  if ((index = interpVersion.indexOf ("sun")) >= 0)    ;
	else
            index = interpVersion.indexOf ("SUN");

	String  versionPart;
	if (index == -1)
	    versionPart = interpVersion;
	else
	    versionPart = interpVersion.substring (index + 3);
                      //3 is length of 'sun'
/* TEST
	System.out.println ("versionpart: [" + versionPart + "]");
*/
	StringBuffer versionNum = new StringBuffer();
	char         c;
	boolean      seenBefore = false;
	for (int indx = 0; indx < versionPart.length(); indx++)
	{
	    c = versionPart.charAt(indx);
	    if (Character.isDigit(c))
		versionNum.append(c);
	    else  if (c == '.')
		if (seenBefore)
		    break;
		else
		    seenBefore = true;
	}
	String version = versionNum.toString();
/* TEST
	System.out.println ("Final version string (no periods): " + version);
*/
	if (version.compareTo("11") >= 0) //version 1.1 or more
	{
	    isVers1_0 = false;
	    // System.out.println ("Version 1.1");
	}
	else
	{
	    isVers1_0 = true;
	    // System.out.println ("Version 1.0");
	}
    }

    public static void setApplet()
    {
	determineInterpVersion();
	isApplet = true;
    }

    public static void setApplication()
    {
	determineInterpVersion();
	isApplet = false;
    }

    public static boolean getIsApplet()
    {
	return  isApplet;
    }

    public static boolean getIsApplication()
    {
	return  (!isApplet);
    }

    public static boolean getIsVersion1_0 ()
    {
	return  isVers1_0;
    }

    public static boolean getIsVersion1_1 ()
    {
	return  (!isVers1_0);
    }

  public static void printSystemProperties() 
  {
    System.out.println("java.version = " + System.getProperty("java.version"));
    System.out.println("java.vendor = " + System.getProperty("java.vendor"));
    System.out.println("os.name = " + System.getProperty("os.name"));
    System.out.println("os.arch = " + System.getProperty("os.arch"));
    System.out.println("os.version = " + System.getProperty("os.version"));
  }
}
